<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Event extends CI_Controller {
    public function __construct() 
    {
        //error_reporting(E_ALL);
        //error_reporting(0);
        parent::__construct();
        $this->load->library('Multiquery');
        $this->load->model('Apimodel');  
    }
    public function upcomingevents(){
        $date= date('Y-m-d').'T00:00:00Z';
        $api_url = "https://www.googleapis.com/calendar/v3/calendars/ehnklb6fhk0c18ah7564d3d1ls@group.calendar.google.com/events?key=AIzaSyCWKs51_osdAvlkkiYbr7xKCXrfh5uDj1A&timeMin=".$date;
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json = json_decode($data);
        $events = $decoded_json->items;
        $attachments = array();
        $manupulated_events =  array();
        $geocode_array =  array();
        $geocode_cnt = 0;
        foreach ($events as $key => $event) {
            $manupulated_events[$key]['id'] = $event->id;
            $manupulated_events[$key]['status'] = $event->status;
            $manupulated_events[$key]['name'] = $event->summary;
            $manupulated_events[$key]['location'] = $event->location;
            if(@$event->start->dateTime){
                $date_time = explode('T', $event->start->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $start_time = date('h:i A', strtotime($formated_date_fn));
                $start_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['start_date'] = @$start_date;
                $manupulated_events[$key]['start_time'] = $start_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->start->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['start_date'] = @$formated_date_fn;
                $manupulated_events[$key]['start_time'] = '';
            }
            if(@$event->end->dateTime){
                $date_time = explode('T', $event->end->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $end_time = date('h:i A', strtotime($formated_date_fn));
                $end_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['end_date'] = @$end_date;
                $manupulated_events[$key]['end_time'] = $end_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->end->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['end_date'] = @$formated_date_fn;
                $manupulated_events[$key]['end_time'] = '';
            }
             $geocode_api = "https://maps.googleapis.com/maps/api/geocode/json?address=".urlencode($event->location)."&key=AIzaSyD_Zq0IxCsxZPSOMdLC-1_JzFmUaxYHlV4";
            $ch = curl_init() or die(curl_error());
            curl_setopt($ch, CURLOPT_URL,$geocode_api);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $data = curl_exec($ch);
            $decoded_json_code = json_decode($data);
            //print_r($decoded_json_code); exit;
            //$formated_date_title = 
            $geocode_array[$key][0] = "<div class='summary'>".@$event->summary.'</div>'.'<br />'.@$start_date."<br /><br />".@$decoded_json_code->results[0]->formatted_address;
            $geocode_array[$key][1] = @$decoded_json_code->results[0]->geometry->location->lat;
            $geocode_array[$key][2] = @$decoded_json_code->results[0]->geometry->location->lng;
            foreach ($event->attachments as $key2 => $attachment) {
                $attachments[$key2]['url']=$attachment->fileUrl;
            }
            $manupulated_events[$key]['attachments'] = $attachments;
        }
        if($manupulated_events){
             $response = array(
                'status' => TRUE,
                'upcoming_events' => $manupulated_events,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function pastevents(){
        $date= date('Y-m-d').'T00:00:00Z';
        $api_url = "https://www.googleapis.com/calendar/v3/calendars/ehnklb6fhk0c18ah7564d3d1ls@group.calendar.google.com/events?key=AIzaSyCWKs51_osdAvlkkiYbr7xKCXrfh5uDj1A&timeMax=".$date;
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json = json_decode($data);
        $events = $decoded_json->items;
        $attachments = array();
        $manupulated_events =  array();
        foreach ($events as $key => $event) {
            $manupulated_events[$key]['id'] = $event->id;
            $manupulated_events[$key]['status'] = $event->status;
            $manupulated_events[$key]['name'] = $event->summary;
            $manupulated_events[$key]['location'] = $event->location;
            if(@$event->start->dateTime){
                $date_time = explode('T', $event->start->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $start_time = date('h:i A', strtotime($formated_date_fn));
                $start_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['start_date'] = @$start_date;
                $manupulated_events[$key]['start_time'] = $start_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->start->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['start_date'] = @$formated_date_fn;
                $manupulated_events[$key]['start_time'] = '';
            }
            if(@$event->end->dateTime){
                $date_time = explode('T', $event->end->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $end_time = date('h:i A', strtotime($formated_date_fn));
                $end_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['end_date'] = @$end_date;
                $manupulated_events[$key]['end_time'] = $end_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->end->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['end_date'] = @$formated_date_fn;
                $manupulated_events[$key]['end_time'] = '';
            }
            $geocode_api = "https://maps.googleapis.com/maps/api/geocode/json?address=".urlencode($event->location)."&key=AIzaSyD_Zq0IxCsxZPSOMdLC-1_JzFmUaxYHlV4";
            $ch = curl_init() or die(curl_error());
            curl_setopt($ch, CURLOPT_URL,$geocode_api);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $data = curl_exec($ch);
            $decoded_json_code = json_decode($data);
            //print_r($decoded_json_code); exit;
            //$formated_date_title = 
            $geocode_array[$key][0] = "<div class='summary'>".@$event->summary.'</div>'.'<br />'.@$start_date."<br /><br />".@$decoded_json_code->results[0]->formatted_address;
            $geocode_array[$key][1] = @$decoded_json_code->results[0]->geometry->location->lat;
            $geocode_array[$key][2] = @$decoded_json_code->results[0]->geometry->location->lng;
            foreach ($event->attachments as $key2 => $attachment) {
                $attachments[$key2]['url']=$attachment->fileUrl;
            }
            $manupulated_events[$key]['attachments'] = $attachments;
        }
        if($manupulated_events){
             $response = array(
                'status' => TRUE,
                'past_events' => $manupulated_events,
                 'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function create_event(){
        $post = json_decode(file_get_contents('php://input'), true);
        //$post =$this->input->post();
        $event_name = $post['event_name'];
        $sdtime = @$post['start_datetime'];
        $edtime = @$post['end_datetime'];
        $address1 = $post['address1'];
        $address2 = @$post['address2'];
        $account_id = @$post['account_id'];
        $state = @$post['state'];
        $user_id = @$post['user_id'];
        $city = @$post['city'];
        $zip = @$post['zip'];
        $dist_id = @$post['distributor_id'];
        $keycnt=0;
        //$suppliers = @$post['suppliers'];
        if($dist_id){
            $suppliers = @$post['suppliers'];
        }
        $data = array(
            'event_name' => $event_name,
            'start_time' => @$this->makedatetime($sdtime),
            'end_time' => @$this->makedatetime_end($sdtime,$edtime),
            'duration' => ($edtime/60)." hr",
            'account_id'=> $account_id,
            'address_line_one' => $address1,
            'address_line_two' => $address2,
            'state' => $state,
            'city' => $city,
            'zip' => $zip,
            'user_id' => $user_id,
            'created_by' => $user_id,
            'created_date' => date('Y-m-d H:i:s') 
        );
        $this->db->insert('ptsl_events',$data);
        //call sp
        $event_id = $this->db->insert_id();
        $full_address = $address1." ".$address2." ".$city." ".$state." ".$zip;
        $this->makelatlong($full_address,$event_id);
        $device_list_array = array();
        $device_list_array__ = array();
        $notification_data_batch = array();
        $stfun = " select ptsl_fn_get_user_info('".$user_id."','name') as name";
        $event_creator_name = $this->db->query($stfun)->row();
        $push_mmsg = "An event has been created by ".$event_creator_name->name;
        $sup_dev_cnt = 0;
        if(!$dist_id){
            $spn3 = "call ptsl_sp_get_device_keys_for_event_invitation('".$user_id."','','".$account_id."');";
            $res__= $this->db->query($spn3);
            //$res__ = $this->Multiquery->GetResults($spn3);
            if($res__){
                $res = $res__->result_array();
                $res__->next_result( $this->db->conn_id ); 
                $res__->free_result();
            }
            

            if($res){
                foreach ($res as  $value) {
                    $notification_data__ = array(
                        'user_id' => $value['user_id'],
                        'notification' => $push_mmsg,
                        'notification_url' => '#/customeventdlt/'.$event_id
                    );
                  	$this->Apimodel->save_notification_data_event($notification_data__);
                    $url = '#/customeventdlt/'.$event_id;
                    $device_list_array__[$sup_dev_cnt++] = $value['device_key'];
                   
                }
                $send_push = $this->send_push($device_list_array__,$event_id,$push_mmsg);
              
            }
        }
        if(@$suppliers){
            foreach($suppliers as $supplier){
                $data2= array(
                    'event_id' => $event_id,
                    'supplier_id' => $supplier['id'],
                    'distributor_id'=> $dist_id
                );
                $supplier_id_fot_not = $supplier['id'];
                $res = $this->db->insert('ptsl_event_supplier',$data2); 
                $notification_data = array(
                    'user_id' => $supplier['supplier_manager_user_id'],
                    'notification' => $push_mmsg,
                    'notification_url' => '#/customeventdlt/'.$event_id
                ); 
                $this->db->insert('ptsl_user_notifications',$notification_data);
                $notification_data = array(
                    'user_id' => $supplier['supplier_rep_user_id'],
                    'notification' => $push_mmsg,
                    'notification_url' => '#/customeventdlt/'.$event_id
                );
                $this->db->insert('ptsl_user_notifications',$notification_data); 
                if($supplier['supplier_manager_user_id'] || $supplier['supplier_rep_user_id']){
                    $sql = "select pn.device_key  from ptsl_users u
LEFT OUTER JOIN ptsl_push_notifications pn on pn.user_id = u.user_id
where 
u.supplier_manager_id in (select id from ptsl_supplier_manager where supplier_id = '".$supplier_id_fot_not."') and CHAR_LENGTH(pn.device_key) > 0

UNION ALL
select pn.device_key  from ptsl_users u
LEFT OUTER JOIN ptsl_push_notifications pn on pn.user_id = u.user_id
where 
u.supplier_rep_id in (select ClientRepID from ptsl_clientrep where supplier_id = '".$supplier_id_fot_not."') and CHAR_LENGTH(pn.device_key) > 0;";

                    $data__ = $this->db->query($sql)->result_array();
                    foreach ($data__ as $key => $value) {
                        $device_list_array[$keycnt++] = $value['device_key'];
                    }
                }
                
                
            }
            $send_push = $this->send_push($device_list_array,$event_id,$push_mmsg);
            
        }
        if($event_id){
            $response = array(
                'status' => TRUE,
                'message' => 'Created Successfully'
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "Event Can not be created"
            );
        echo json_encode($response);
        }
    }
    public function custom_event_details(){
        $event_id = $this->input->get('event_id');
        $user_id = $this->input->get('user_id');
        $spn = "call ptsl_sp_get_event('".$user_id."','".$event_id."')";
        $data = $this->db->query($spn)->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'event_details' => $data[0]
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No data found"
            );
        echo json_encode($response);
        }
    }
    public function get_upcoming_events(){
        $brand = @$this->input->get('brand');
        $user_id = @$this->input->get('user_id'); 
        $is_current = @$this->input->get('type'); 
        $spn = "Call ptsl_sp_get_event_list('".$user_id."','".$is_current."', '".$brand."')";
        //echo $spn;
        $upcomingevents = $this->db->query($spn)->result_array(); 
        if($upcomingevents){
             $response = array(
                'status' => TRUE,
                'upcoming_events' => $upcomingevents
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_past_events(){
        $brand = @$this->input->get('brand');
        $user_id = @$this->input->get('user_id');
        $is_current = 0;
        $spn = "Call ptsl_sp_get_event_list('".$user_id."','".$is_current."', '".$brand."')";
        $upcomingevents = $this->db->query($spn)->result_array();
        if(@$upcomingevents){
             $response = array(
                'status' => TRUE,
                'past_events' => $upcomingevents,
                
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_map_data(){
        $type = @$this->input->get('type');
        $brand = @$this->input->get('brand');
        $is_map = 1;
        $spn = "call ptsl_sp_get_eventmap_by_filter('".$type."','".$brand."')";
        $data_arr = $this->db->query($spn)->result_array();
        foreach($data_arr as $key => $data){
            $upcomingevents[$key]['name'] = $data['event_name'];
            $event_id = $data['id'];
            $duration = $data['start_date_time']." - ".$data['end_time'];
            $redirect_url_name = "#/customeventdlt/".$event_id;
            $loc_str = $data['full_address'];
            $upcomingevents[$key]['location'] = $data['full_address'];
            
            $geocode_array[$key][0] = '<div class="summary"><a href="'.$redirect_url_name.'">'.@$data['event_name'].'</a></div><br/>'.$duration.'<br /><br />'.@$loc_str;
            $geocode_array[$key][1] = $data['lattitude'];
            $geocode_array[$key][2] = $data['longitude'];
        }
        if(@$geocode_array){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_event_subtype(){
    	$this->db->select('ActivitySubtypeID as id, SubTypeName as name');
        $this->db->where('Ptsl_ActivityType_ActivityTypeID',2);
    	$data = $this->db->get('ptsl_activitysubtype')->result_array();
    	if($data){
             $response = array(
                'status' => TRUE,
                'event_subtypes' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_account_event($supplier_id){
        $prefix= '';
        $supplier = $supplier_id;
        $distributor ='';
        $spn = "Call ptsl_sp_search_account(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();
        if($data){
             $response = array(
                //'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_account_event_dist($dist_id){
        $prefix= '';
        $supplier = '';
        $distributor =$dist_id;
        $spn = "Call ptsl_sp_search_account(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();
        if($data){
             $response = array(
                //'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_account_event_for_crtevent(){
        $post = json_decode(file_get_contents('php://input'), true);
    	$prefix= @$post['key'];
        $supplier = @$post['supplier'];
        $distributor =@$post['distributor'];
        $spn = "Call ptsl_sp_search_account(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();
    	if($data){
             $response = array(
                'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_account_city(){
        //$post = json_decode(file_get_contents('php://input'), true);
        //$prefix= $post['key'];
        $prefix = "";
        $spn = "Call ptsl_sp_get_city(?)";
        $data = $this->db->query($spn,array($prefix))->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function addevent(){
    	$post_data = json_decode(file_get_contents('php://input'), true);
        //print_r($post_data);
        //echo json_encode($post_data);  return;
    	//$Buyer = @$post_data['buyer'];
    	//$spokewith = @$post_data['spokewith'];
    	$InternalNotes = @$post_data['internal_note'];
    	$notes = @$post_data['note'];
    	$BrandExposure = @$post_data['brand'];
    	$CreatedBy = @$post_data['user_id'];
        $user_id = $CreatedBy;
    	//$Client_Rep_ID = @$post_data['supplier_rep_id'];
    	$CreatedDate = date('Y-m-d');
    	$event_name = @$post_data['event_name'];
    	//$ActivityImage = @$post_data['image'];
    	//$ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $subtype = @$post_data['subtype'];
    	$idAcc = @$post_data['account_id'];
        $participants = @$post_data['participants'];
        if($idAcc){
            $ptsl_accountinfo_AccountID = @$idAcc['id'];
        }
        if($subtype){
            $ptsl_activitySubtype_ActivitySubtypeID = $subtype;
        }
        else{
            $ptsl_activitySubtype_ActivitySubtypeID = 0;
        } 
        
        $isEvent =1;
        if(!$event_name){
            $response = array(
                'status' => FALSE,
                'message'=> "Event Name is required"
            );
            echo json_encode($response);
            return;
        }
        	
        if(!$ptsl_activitySubtype_ActivitySubtypeID){
        	$response = array(
        		'status' => FALSE,
        		'message'=> "Event Type is required"
        	);
        	echo json_encode($response);
        	return;
        }else{
	
        	$ActivityDate = date('Y-m-d');
        	$data = array(
        		//'ActivityTypeID' => $ActivityTypeID,
        		'InternalNotes'  => $InternalNotes,
        		'Notes'          => $notes,
        		'BrandExposure'  => $BrandExposure,
        		'CreatedBy'      => $CreatedBy,
        		'CreatedDate'    => $CreatedDate,
        		'ActivityDate'	 => $ActivityDate,
                'user_id'  => $user_id,	
        		'isEvent' => $isEvent,
        		'EventName' => $event_name,		
        		//'ActivityImage'  => $ActivityImage,
        		'ptsl_activitySubtype_ActivitySubtypeID'=> $ptsl_activitySubtype_ActivitySubtypeID,
        		'AccountID' => @$ptsl_accountinfo_AccountID
        	);
        	$add_activity = $this->db->insert('ptsl_account_activity',$data);
        	$acitivity_id = $this->db->insert_id();

        	//participants
            if($participants){
                foreach($participants as $participant){
                    if(@$participant['selected'] == 1){
                        $data2= array(
                            'ActivityID' => $acitivity_id,
                            'ParticipantID' => $participant['id']
                        );
                        $res = $this->db->insert('ptsl_activity_participants',$data2);
                    }

                }
            }
        	
        	
            if(@$post_data['photos']){    
                $images = $post_data['photos'];
                $photo_taken_date = date("Y-m-d H:i:s");
                foreach ($images as $key => $image) {
                    //create thum
                    $loc="../accountapi_dev/temp/img".date('YmdHis');
                    $imgData1 = $image;
                    $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                    $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                    file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                    $image_file=$loc.'MyFile.jpg';
                    $target_file = $image_file;
                    $thumbnail = "../accountapi_dev/thumb/".date('YmdHis')."file.jpg";
                    $wthumb = 100;
                    $hthumb = 100;
                    $fileExt="jpg";
                    $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                    $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                    $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb;
                    unlink($thumbnail);    
                    $data_img = array(
                            'ActivityID' => $acitivity_id,
                            'Photo' => $image,
                            'thumbnail' => $jpg_encoded_thumb,
                            'taken_date' => $photo_taken_date,
                            'user_id' => $CreatedBy
                        );
                    $res = $this->db->insert('ptsl_activity_photos',$data_img); 
                }
            }
        	if($add_activity){
        		$response = array(
        			'status' => TRUE,
                    'event_id'=>$acitivity_id,
        			'message'=> "Event Inserted Successfully"
        		);
        		echo json_encode($response);
        	}
        	else{
        		$response = array(
        			'status' => FALSE,
        			'message'=> "Internal Error"
        		);
        		echo json_encode($response);	
        	}
        }
    }
     public function updateevent(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $InternalNotes = @$post_data['internal_note'];
        $notes = @$post_data['note'];
        $BrandExposure = @$post_data['brand'];
        $CreatedBy = @$post_data['user_id'];
        $CreatedDate = date('Y-m-d');
        $event_name = @$post_data['event_name'];
        //$ActivityImage = @$post_data['image'];
        $ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $idAcc = @$post_data['account_id'];
        $event_id = $post_data['event_id'];
        $activity_id = $event_id;
        if($idAcc){
            $ptsl_accountinfo_AccountID = @$idAcc['id'];
        }else{
            $ptsl_accountinfo_AccountID = '';
        } 
        
        //multiple accout rep id 
        $participants = @$post_data['participants'];
        //$ptsl_activitySubtype_ActivitySubtypeID = 1;
        $isEvent =1;
        
        /*if(!$ptsl_activitySubtype_ActivitySubtypeID){
            $response = array(
                'status' => FALSE,
                'message'=> "Event Type is required"
            );
            echo json_encode($response);
            return;
        }*/
         /*if(!$event_name){
            $response = array(
                'status' => FALSE,
                'message'=> "Event Name is required"
            );
            echo json_encode($response);
            return;
        }*/
        $UpdatedDate = date('Y-m-d');
        $data = array(
            'UpdatedBy'      => $CreatedBy,
            'UpdatedDate'    => $UpdatedDate,   
            'isEvent' => $isEvent,

        );
        if(@$ptsl_accountinfo_AccountID){
            //array_push($data, var)
            $data['AccountID'] = $ptsl_accountinfo_AccountID;
        }
        if(@$ptsl_activitySubtype_ActivitySubtypeID){
            $data['ptsl_activitySubtype_ActivitySubtypeID']= $ptsl_activitySubtype_ActivitySubtypeID;
        }
        if(@$event_name){
            $data['EventName'] = $event_name;
        }
        if(@$InternalNotes){
            $data['InternalNotes'] = $InternalNotes;
        }
        if(@$notes){
            $data['Notes'] = $notes;
        }
        if(@$BrandExposure){
            $data['BrandExposure'] = $BrandExposure; 
        }
        $this->db->where('ActivityID',$event_id);
        $add_activity = $this->db->update('ptsl_account_activity',$data);
        if($participants){
            $this->db->where('ActivityID',$event_id);
            $this->db->delete('ptsl_activity_participants');
            foreach($participants as $participant){
                if(@$participant['selected'] == 1){
                    $data2= array(
                        'ActivityID' => $event_id,
                        'ParticipantID' => $participant['id']
                    );
                    $res = $this->db->insert('ptsl_activity_participants',$data2);
                }

            }
        }
        if(@$post_data['photos']){    
            $images = $post_data['photos'];
            $photo_taken_date = date('Y-m-d H:i:s');
            foreach ($images as $key => $image) {
                $loc="../accountapi/temp/img".date('YmdHis');
                $imgData1 = $image;
                $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                //$sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                $image_file=$loc.'MyFile.jpg';
                $target_file = $image_file;
                $thumbnail = "../accountapi/thumb/".date('YmdHis')."file.jpg";
                $wthumb = 100;
                $hthumb = 100;
                $fileExt="jpg";
                $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb;
                unlink($thumbnail);  
                $data_img = array(
                        'ActivityID' => $event_id,
                        'Photo' => $image,
                        'thumbnail' => $jpg_encoded_thumb,
                        'taken_date' => $photo_taken_date,
                        'user_id' => $CreatedBy
                    );
                $res = $this->db->insert('ptsl_activity_photos',$data_img); 
            }
        }
        if($add_activity){
            $response = array(
                'status' => TRUE,
                //'event_id'=>$acitivity_id,
                'message'=> "Event Updated Successfully"
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message'=> "Internal Error"
            );
            echo json_encode($response);    
        }
    }
     public function get_event_details($id,$user_id){
        $this->db->select('acc.LongName,stype.Ptsl_ActivityType_ActivityTypeID,acc.AccountID,act.ActivityID,stype.SubTypeName,act.EventName,act.Buyer,act.spokewith,act.InternalNotes,act.Notes,DATE_FORMAT(act.ActivityDate,"%m-%d-%y") as ActivityDate, act.BrandExposure, act.DecisionMaker, act.BestTimeToVisit_day');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID = act.AccountID','left');
        //$this->db->join('ptsl_activitytype as type','act.ActivityTypeID=type.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as stype','act.ptsl_activitySubtype_ActivitySubtypeID=stype.ActivitySubtypeID','');
        //$this->db->join('ptsl_activity_photos',);
        $this->db->where('act.ActivityID',$id);
        //$this->db->where('stype.Ptsl_ActivityType_ActivityTypeID',2);
        $data['activity'] = $this->db->get()->row();
        $photos_id_array = array();
        if($data){
            $sql = "select ptsl_fn_get_participants_comma('".$id."') as participants;";
            $participants = $this->db->query($sql)->row();
            $data['participant_names'] = $participants->participants;
            $spn = "Call ptsl_sp_get_photos_activity('".$user_id."','".$id."')";
            $data_photos = $this->multiquery->GetResults($spn); 
            $new_array = array(); 
            foreach($data_photos[1] as $key=>$adata){
                $new_array[$key]['id'] =$key;
                $photos_id_array[$key]['PhotoID'] = $adata['PhotoID'];
                $new_array[$key]['src'] = $adata['thumbnail'];
                $new_array[$key]['ActivityID'] = $adata['ActivityID'];
                $new_array[$key]['title'] = $adata['photo_title'];
                $new_array[$key]['number_of_comments'] = $adata['number_of_comments'];
            }
           
            $response= array(
                'status' => TRUE,
                'event_details' => $data,
                'photos' => $new_array,
                'photos_id' =>$photos_id_array
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
        
    }
    public function getPhotosidbyActivityid($id){
        $this->db->select('p.PhotoID');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
        $this->db->where('a.ActivityID',$id);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos_id' => $data  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
      public function get_event_details_edit($id){
        $this->db->select('acc.LongName,stype.Ptsl_ActivityType_ActivityTypeID,acc.AccountID,act.ActivityID,stype.SubTypeName,act.EventName,act.Buyer,act.spokewith,act.InternalNotes,act.Notes,act.ActivityDate,act.BrandExposure,act.DecisionMaker');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID = act.AccountID','left');
        //$this->db->join('ptsl_activitytype as type','act.ActivityTypeID=type.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as stype','act.ptsl_activitySubtype_ActivitySubtypeID=stype.ActivitySubtypeID','');
        //$this->db->join('ptsl_activity_photos',);
        $this->db->where('act.ActivityID',$id);
        //$this->db->where('stype.Ptsl_ActivityType_ActivityTypeID',2);
        $data['activity'] = $this->db->get()->row();
        if($data){
          //  $this->db->select('photo');
           // $this->db->where('ActivityID',$id);
           // $photos = $this->db->get('ptsl_activity_photos')->result_array();
            $this->db->select('rep.ClientRepName as name,par.ParticipantID');
            $this->db->join('ptsl_clientrep rep','rep.ClientRepID = par.ParticipantID');
            $this->db->where('par.ActivityID',$id);
            $participants = $this->db->get('ptsl_activity_participants par')->result_array();
            $part_names = "";
            foreach($participants as $participant){
                $part_names = $part_names.$participant['name'].", ";
            }
            $selected_part_name = trim($part_names, ',');
            $data['par_names'] = $selected_part_name;
            $data['participants'] = $participants;
             $response = array(
                'status' => TRUE,
                'activity' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function suppliers($dist_id){
        $this->db->select('sup.id, sup.supplier_name as name');
        $this->db->from('ptsl_supplier sup');
        $this->db->join('ptsl_distributor_supplier dist','dist.supplier_id=sup.id','');
        $this->db->where('dist.distributor_id',$dist_id);
        $data = $this->db->get()->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function suppliers_by_city(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $user_id = $post_data['user_id'];
        $city = $post_data['city'];
        $spn = "Call ptsl_sp_get_supplier_list_by_city('".$user_id."', '".$city."')";
        $data = $this->multiquery->GetResults($spn); 
        if($data){
            $response = array(
                'status' => TRUE,
                'users' => $data[1]
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function suppliers_by_userid(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $user_id = $post_data['user_id'];

        $spn = "Call ptsl_sp_get_supplier_list_by_dist_user('".$user_id."')";
        $data = $this->multiquery->GetResults($spn); 

        if($data){
            $response = array(
                'status' => TRUE,
                'users' => $data[2]
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function can_addevent($user_id){
        $spn = "select ptsl_fn_view_permission('".$user_id."','add_event') as perm";
        $data = $this->db->query($spn)->row(); 
        if($data){
            $response = array(
                'status' => TRUE,
                'res' => $data->perm
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function test($id){
        $this->db->select('thumbnail');
        $data = $this->db->get_where('ptsl_activity_photos',array('PhotoID'=>$id))->result_array();
        $img = $data[0]['thumbnail'];
        echo '<img src="'.$img.'" />';
    }
    public function get_citystate_by_zip($zip){
        $api_url ="https://maps.googleapis.com/maps/api/geocode/json?address=".$zip."&sensor=true&key=AIzaSyD_Zq0IxCsxZPSOMdLC-1_JzFmUaxYHlV4";
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json = json_decode($data);
        if($decoded_json){
        	$address_components  = @$decoded_json->results[0]->address_components;
            foreach($address_components as $key=>$result){
           
            	 if($result->types[0]== 'locality' || $result->types[0]== 'neighborhood'){
            	 	$city = $result->short_name;
            	 }
            	 if($result->types[0]== 'administrative_area_level_1'){
            	 	$state = $result->short_name;
            	 }
            }
            $data = array(
                'city' => $city,
                'state' => $state
            );
            $response = array(
                'status' => TRUE,
                'info' => $data
            );
            echo json_encode($response);
        }else{
           $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
            echo json_encode($response); 
        }
    }
    private function ak_img_thumb($target, $newcopy, $w, $h, $ext) {
        list($w_orig, $h_orig) = getimagesize($target);
        $src_x = ($w_orig / 2) - ($w / 2);
        $src_y = ($h_orig / 2) - ($h / 2);
        $ext = strtolower($ext);
        $img = "";
        if ($ext == "gif"){ 
        $img = imagecreatefromgif($target);
        } else if($ext =="png"){ 
        $img = imagecreatefrompng($target);
        } else { 
        $img = imagecreatefromjpeg($target);
        }
        $tci = imagecreatetruecolor($w, $h);
        //imagecopyresampled($tci, $img, 0, 0, $src_x, $src_y, $w, $h, $w_orig, $h_orig);
        imagecopyresampled($tci, $img, 0, 0, 0, 0, $w, $h, $w_orig, $h_orig);
        if ($ext == "gif"){ 
            imagegif($tci, $newcopy);
        } else if($ext =="png"){ 
            imagepng($tci, $newcopy);
        } else { 
           $t= imagejpeg($tci, $newcopy, 84);
        }
    }
    private function makedatetime($p_date){
        $date=strtotime($p_date);
        $acdate =  date("Y-m-d H:i:s",$date);
        return $acdate;
    }
    private function makedatetime_end($pdate,$dt){
        $date=strtotime($pdate);
        $acdate =  date("Y-m-d H:i:s",$date);
        $minutes_to_add = $dt;
        $time = new DateTime($acdate);
        $time->add(new DateInterval('PT' . $minutes_to_add . 'M'));
        $stamp = $time->format('Y-m-d H:i:s');
        return $stamp;
    }
    private function send_email($emails,$subject,$body){
        /*$config = Array(
            'protocol' => 'smtp',
            'smtp_host' => 'smtp.gmail.com',
            'smtp_port' => 587,
            'smtp_user' => 'periscopedemo@gmail.com',
            'smtp_pass' => 'Newyork11',
            'mailtype'  => 'html', 
            'charset'   => 'utf-8'
        );*/
        $config = Array(
            'mailtype'  => 'html', 
            'charset'   => 'iso-8859-1'
        );
        $this->load->library('email');
        $this->email->initialize($config);
        foreach($emails as $email){
            $this->email->set_newline("\r\n");
            $this->email->to($email['email']);
            $this->email->from('periscopedemo@gmail.com');
            $this->email->subject($subject);
            $this->email->message($body);
            $result = $this->email->send();
        }
    }
    private function send_push($devices_associative_arr,$id,$msg){
        $devices =array();
        $devices = $devices_associative_arr;
        $content = array(
          "en" => $msg
          );
        
       $fields = array(
      'app_id' => "e13a6f2b-74f2-4cb8-a109-b4af95c293ce",
     // 'included_segments' => array('All'),
      //'included_segments' => array('789e714d-7e95-4a1f-a65c-75f967f442a3'),
      'include_player_ids' => $devices,
      'data' => array("state" => "customeventdlt","param"=>$id,"type_id"=>3),
      'contents' => $content,
      "ios_badgeType" => "Increase",
      "ios_badgeCount"=> 1
  

    );
        
        $fields = json_encode($fields);
       // print("\nJSON sent:\n");
        //print($fields);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                               'Authorization: Basic OTQ0YWM4ODQtNjNjZi00MzJjLThhMjgtZjdiZTcyYWY3YTJl'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);
        
        return $response;
    }
     
    private function makelatlong($address,$event_id){

        $geocode_api = "https://maps.googleapis.com/maps/api/geocode/json?address=".urlencode($address)."&key=AIzaSyD_Zq0IxCsxZPSOMdLC-1_JzFmUaxYHlV4";
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$geocode_api);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json_code = json_decode($data);
        if($decoded_json_code){
            $lat = @$decoded_json_code->results[0]->geometry->location->lat;
            $long = @$decoded_json_code->results[0]->geometry->location->lng;
            $data1['lattitude'] = $lat;
            $data1['longitude'] = $long;
            $this->db->where('id',$event_id);
            $res = $this->db->update('ptsl_events',$data1);
            return $res; 
        }
        
    }
    
}