<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Notification extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        $this->load->library('Multiquery');  
    }

    public function allow_notification($val,$user_id){
    	$this->db->where('user_id',$user_id);
    	$data = $this->db->update('ptsl_user_settings',array('allow_notification'=>$val));
    	if($data){
             $response = array(
                'status' => TRUE,
                'message' => 'Updated Successfully'
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function setting_list($user_id){
    	$this->db->where('user_id',$user_id);
    	$data = $this->db->get('ptsl_user_settings')->row();
    	if($data){
             $response = array(
                'status' => TRUE,
                'list' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function notification_list($user_id){
    	$spn = "Call ptsl_sp_get_notification_list('".$user_id."')";
    	$data = $this->db->query($spn)->result_array();
    	if($data){
             $response = array(
                'status' => TRUE,
                'list' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
}