<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Recent_sales extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }

    public function index(){
    	$state = @$this->input->get('state');
    	$region_name = @urldecode($this->input->get('region'));
    	$rep = @$this->input->get('rep');
        $region ="";
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        $data_mdate = $this->db->query('SELECT max(raw_date)  as mdate FROM ptsl_sales_transactions')->result_array();
        $max_date = $data_mdate[0]['mdate'];
    	/*$this->db->select('tran.brand_and_packaging as sku,tran.raw_account_name as LongName,date_format(tran.raw_date,"%M %d, %Y") as date,rep.ClientRepName');
    	$this->db->from(' ptsl_sales_transactions tran');
    	$this->db->join('ptsl_clientrep rep','rep.ClientRepID= tran.client_rep_id','');
    	$data = $this->db->get()->result_array();*/
    	$sql = "SELECT `tran`.`brand_and_packaging` as `sku`,tran.units as unit,  `tran`.`raw_account_name` as `LongName`, date_format(tran.raw_date, '%M %d, %Y') as date, `rep`.`ClientRepName`
			FROM `ptsl_sales_transactions` `tran`
			JOIN `ptsl_clientrep` `rep` ON `rep`.`ClientRepID`= `tran`.`client_rep_id` where raw_date >= DATE('".$max_date."') - INTERVAL 7 DAY";
		if($region && $state && $rep){ //111
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep ;	
		}
		if($region && !$state && !$rep){ //100
			$sql = $sql.' and tran.region='.$region;
		}
		if($region && $state && !$rep){ //110
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'"';
		}
		if($region && !$state && $rep){//101
			$sql = $sql.' and tran.client_rep_id='.$rep.' and tran.region='.$region;
		}
		if(!$region && !$state && $rep){//001
			$sql = $sql.' and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && $rep){//011
			$sql = $sql.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && !$rep){//010
			$sql = $sql.' and tran.raw_state="'.$state.'"';
		}
        $sql = $sql.' order by tran.raw_date desc,tran.order_id desc ';	
    	$data = $this->db->query($sql)->result_array();

    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_sales' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function filter_v2(){
        $state = @$this->input->get('state');
        $range = @$this->input->get('range');
        $region_name = @urldecode($this->input->get('region'));
        $rep = @$this->input->get('rep');
        $region ="";
        $supplier_id = @$this->input->get('supplier');
        $is_map = @$this->input->get('ismap');
        if($is_map==1){
            $map = 1;
        }else{
            $map = 0;
        }
        if(!$range){
            $range = 7;
        }else{
            $range = $range;
        }
        
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        if($region){
            $this->db->where('region',$region);
        }
        if($state){
            $this->db->where('raw_state',$state);
        }
        if($rep){
            $this->db->where('client_rep_id',$rep);
        }
        if($supplier_id){
            $this->db->where('supplier_id',$supplier_id);
        }
        if($range){
            $this->db->where('DATE_ADD(ConvertedDate, INTERVAL - '.$range.' day)');
        }
        $data = $this->db->get('ptsl_vw_recent_sales')->result_array();
        if($data){
            $cnt = 0;
            foreach($data as $key=>$rec_data){
                $name = $rec_data['LongName'];
                $address = $rec_data['full_address'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$rec_data["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $rec_data['latitude'];
                $geocode_array[$cnt][2] = $rec_data['longitude'];
                $cnt++;
            }
        
            $response = array(
                'status' => TRUE,
                'recent_sales' => $data,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
         
    }

}